import { Expression, Serialiser } from './types';
/**
 * @public
 */
export declare class ExpressionBuilder {
    private field;
    private value;
    private serialiser;
    private params;
    private valueGetter;
    private group;
    constructor(opts?: Partial<{
        field: string;
        value: unknown;
        serialiser: Serialiser;
        params: any;
        valueGetter: (value: unknown) => string;
        group: string;
    }>);
    withField(field: string): ExpressionBuilder;
    withValue(value: unknown): ExpressionBuilder;
    withSerialiser(serialiser: Serialiser): ExpressionBuilder;
    withParams(params: any): ExpressionBuilder;
    withValueGetter(valueGetter: (value: unknown) => string): ExpressionBuilder;
    withGroup(group: string): ExpressionBuilder;
    build: () => Expression;
}
//# sourceMappingURL=expression-builder.d.ts.map