## API Report File for "@genesislcap/foundation-criteria"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { FASTElement } from '@microsoft/fast-element';

// @public (undocumented)
export const createFormCriteriaBuilder: <T>(criteriaBuilder: CriteriaBuilder) => (config: ExpressionConfig, formValue: any, formData: T) => void;

// @public
export class CriteriaBuilder {
    // (undocumented)
    And: (expression: ValidExpressionType, options?: ExpressionOptions) => this;
    // Warning: (ae-forgotten-export) The symbol "GroupedExpressions" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    build(outputFn?: (groups: GroupedExpressions) => string): string;
    // (undocumented)
    Not: (expression: ValidExpressionType, options?: ExpressionOptions) => this;
    // (undocumented)
    Or: (expression: ValidExpressionType, options?: ExpressionOptions) => this;
    // (undocumented)
    reset(): void;
    // Warning: (ae-forgotten-export) The symbol "ValidExpressionType" needs to be exported by the entry point index.d.ts
    // Warning: (ae-forgotten-export) The symbol "ExpressionOptions" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    withExpression(expression: ValidExpressionType, options?: ExpressionOptions, groupJoin?: Join): this;
}

// @public
export class CriteriaSegmentedControl extends FASTElement {
    // Warning: (ae-incompatible-release-tags) The symbol "criteriaOptions" is marked as @public, but its signature references "CriteriaSegmentedControlOption" which is marked as @internal
    //
    // (undocumented)
    criteriaOptions: CriteriaSegmentedControlOption[];
    // (undocumented)
    itemClickHandler(label: string): void;
    // (undocumented)
    selectedLabel: string;
    // (undocumented)
    selectedLabelChanged(): void;
    // (undocumented)
    value: string;
    // (undocumented)
    valueChanged(): void;
}

// Warning: (ae-internal-missing-underscore) The name "CriteriaSegmentedControlOption" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type CriteriaSegmentedControlOption = {
    field: string;
    value: unknown;
    serialiser: Serialiser;
    label: string;
};

// Warning: (ae-internal-missing-underscore) The name "Expression" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type Expression = {
    field: string;
    value: unknown;
    serialiser: Serialiser;
    params: any;
    valueGetter?: (value: unknown) => string;
    group: string;
};

// @public (undocumented)
export class ExpressionBuilder {
    constructor(opts?: Partial<{
        field: string;
        value: unknown;
        serialiser: Serialiser;
        params: any;
        valueGetter: (value: unknown) => string;
        group: string;
    }>);
    // Warning: (ae-incompatible-release-tags) The symbol "build" is marked as @public, but its signature references "Expression" which is marked as @internal
    //
    // (undocumented)
    build: () => Expression;
    // (undocumented)
    withField(field: string): ExpressionBuilder;
    // (undocumented)
    withGroup(group: string): ExpressionBuilder;
    // (undocumented)
    withParams(params: any): ExpressionBuilder;
    // Warning: (ae-incompatible-release-tags) The symbol "withSerialiser" is marked as @public, but its signature references "Serialiser" which is marked as @internal
    //
    // (undocumented)
    withSerialiser(serialiser: Serialiser): ExpressionBuilder;
    // (undocumented)
    withValue(value: unknown): ExpressionBuilder;
    // (undocumented)
    withValueGetter(valueGetter: (value: unknown) => string): ExpressionBuilder;
}

// @public
export type ExpressionConfig<T = unknown, V = unknown, Y = unknown> = {
    criteria: (value: V, filters: T) => ExpressionParams<Y> | Array<ExpressionParams<Y>>;
};

// @public
export type ExpressionConfigMap<T, Y = unknown> = Partial<{
    [key in keyof T]: ExpressionConfig<T, T[key], Y>;
}>;

// Warning: (ae-internal-missing-underscore) The name "ExpressionList" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type ExpressionList = Array<Expression | Join | ExpressionList>;

// Warning: (ae-forgotten-export) The symbol "ExpressionValueType" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-missing-underscore) The name "ExpressionParams" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type ExpressionParams<GroupName = ''> = [
string | string[],
Serialiser,
ExpressionValueType | ExpressionValueType[],
boolean?,
GroupName?
];

// @public
export class Join {
    // Warning: (ae-incompatible-release-tags) The symbol "__constructor" is marked as @public, but its signature references "Operator" which is marked as @internal
    constructor(type: Operator);
    // (undocumented)
    static And(): Join;
    // (undocumented)
    static Equal(): Join;
    // (undocumented)
    static GreaterThan(): Join;
    // (undocumented)
    static GreaterThanOrEqual(): Join;
    // (undocumented)
    static LessThan(): Join;
    // (undocumented)
    static LessThanOrEqual(): Join;
    // (undocumented)
    static Not(): Join;
    // (undocumented)
    static NotEqual(): Join;
    // Warning: (ae-incompatible-release-tags) The symbol "operator" is marked as @public, but its signature references "Operator" which is marked as @internal
    //
    // (undocumented)
    get operator(): Operator;
    // (undocumented)
    static Or(): Join;
}

// Warning: (ae-internal-missing-underscore) The name "Operator" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export enum Operator {
    // (undocumented)
    AND = "&&",
    // (undocumented)
    EQ = "==",
    // (undocumented)
    GE = ">=",
    // (undocumented)
    GT = ">",
    // (undocumented)
    LE = "<=",
    // (undocumented)
    LT = "<",
    // (undocumented)
    NE = "!=",
    // (undocumented)
    NOT = "!",
    // (undocumented)
    OR = "||"
}

// Warning: (ae-internal-missing-underscore) The name "Serialiser" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type Serialiser = (e: Expression) => string;

// @public
export const Serialisers: {
    AND: (e: Expression) => string;
    OR: (e: Expression) => string;
    NOT: (e: Expression) => string;
    GT: (e: Expression) => string;
    GE: (e: Expression) => string;
    LT: (e: Expression) => string;
    LE: (e: Expression) => string;
    NE: (e: Expression) => string;
    EQ: (e: Expression) => string;
    equals: (e: Expression) => string;
    equalsIgnoreCase: (e: Expression) => string;
    contains: (e: Expression) => string;
    fieldContains: (e: Expression) => string;
    containsIgnoreCase: (e: Expression) => string;
    dateIsEqual: (e: Expression) => string;
    dateIsGreaterEqual: (e: Expression) => string;
    dateIsLessEqual: (e: Expression) => string;
};

// Warnings were encountered during analysis:
//
// src/expression-builder.ts:19:7 - (ae-incompatible-release-tags) The symbol "serialiser" is marked as @public, but its signature references "Serialiser" which is marked as @internal
// src/serialisers.ts:24:25 - (ae-incompatible-release-tags) The symbol "AND" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:26:3 - (ae-incompatible-release-tags) The symbol "OR" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:27:3 - (ae-incompatible-release-tags) The symbol "NOT" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:28:3 - (ae-incompatible-release-tags) The symbol "GT" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:29:3 - (ae-incompatible-release-tags) The symbol "GE" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:30:3 - (ae-incompatible-release-tags) The symbol "LT" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:31:3 - (ae-incompatible-release-tags) The symbol "LE" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:32:3 - (ae-incompatible-release-tags) The symbol "NE" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:33:3 - (ae-incompatible-release-tags) The symbol "EQ" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:34:3 - (ae-incompatible-release-tags) The symbol "equals" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:35:3 - (ae-incompatible-release-tags) The symbol "equalsIgnoreCase" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:36:3 - (ae-incompatible-release-tags) The symbol "contains" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:37:3 - (ae-incompatible-release-tags) The symbol "fieldContains" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:38:3 - (ae-incompatible-release-tags) The symbol "containsIgnoreCase" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:39:3 - (ae-incompatible-release-tags) The symbol "dateIsEqual" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:40:3 - (ae-incompatible-release-tags) The symbol "dateIsGreaterEqual" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/serialisers.ts:41:3 - (ae-incompatible-release-tags) The symbol "dateIsLessEqual" is marked as @public, but its signature references "Expression" which is marked as @internal
// src/types.ts:47:3 - (ae-incompatible-release-tags) The symbol "criteria" is marked as @public, but its signature references "ExpressionParams" which is marked as @internal

// (No @packageDocumentation comment for this package)

```
