<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-criteria](./foundation-criteria.md) &gt; [CriteriaSegmentedControl](./foundation-criteria.criteriasegmentedcontrol.md)

## CriteriaSegmentedControl class

Main class which defines the criteria segmented control component.

**Signature:**

```typescript
export declare class CriteriaSegmentedControl extends FASTElement 
```
**Extends:** FASTElement

## Remarks

Displays segmented criteria and dispatches events with the selected criteria.

## Example

Example of using the component:

```

const toolbarOptions: CriteriaSegmentedControlOption[] = [
  { label: 'A', field: 'INSTRUMENT_ID', value: 'id1', serialiser: Serialisers.EQ },
  { label: 'B', field: 'INSTRUMENT_ID', value: 'id2', serialiser: Serialisers.EQ },
  { label: 'C', field: 'INSTRUMENT_ID', value: 'id3', serialiser: Serialisers.EQ },
];

 <criteria-segmented-control
   :criteriaOptions=${() => toolbarOptions}
   :value=${sync((x) => x.criteriaFilter)}
 >
   <label slot="label">Filter by instrument name</label>
 </criteria-segmented-control>
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [criteriaOptions](./foundation-criteria.criteriasegmentedcontrol.criteriaoptions.md) |  | CriteriaSegmentedControlOption\[\] |  |
|  [selectedLabel](./foundation-criteria.criteriasegmentedcontrol.selectedlabel.md) |  | string |  |
|  [value](./foundation-criteria.criteriasegmentedcontrol.value.md) |  | string |  |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [itemClickHandler(label)](./foundation-criteria.criteriasegmentedcontrol.itemclickhandler.md) |  |  |
|  [selectedLabelChanged()](./foundation-criteria.criteriasegmentedcontrol.selectedlabelchanged.md) |  |  |
|  [valueChanged()](./foundation-criteria.criteriasegmentedcontrol.valuechanged.md) |  |  |

